<template>
  <div>{{shown}}</div>
  <div
    ref="rootRef"
    class="cupertino-pane"
  >
    <h1>Header</h1>
    <div class="content">
      <slot/>
    </div>    
  </div>
</template>

<script setup lang="ts">
import type { PropType } from 'vue'
import type { CupertinoSettings } from 'cupertino-pane'
import { CupertinoPane } from 'cupertino-pane'

const pane = ref<CupertinoPane>()
const rootRef = ref<HTMLElement>()
const emit = defineEmits(['update:shown'])
const props = defineProps({
  parentElement: {
    type: [String, HTMLElement],
    default: 'body'
  },
  breaks: {
    type: Object as PropType<Required<CupertinoSettings>['breaks']>,
    default: () => ({}) as Required<CupertinoSettings>['breaks']
  },
  initialBreak: {
    type: String as PropType<Required<CupertinoSettings>['initialBreak']>,
    default: 'bottom',
  },
  fitHeight: {
    type: Boolean,
    default: false,
  },
  shown: {
    type: Boolean,
    default: false,
  },
  settings: {
    type: Object as PropType<Omit<CupertinoSettings, 'events'|'parentElement'>>,
    default: () => {
      return { 

      }
    }
  }
})

onMounted(() => {
  const instancePane = new CupertinoPane(
    rootRef.value,
    {
      ...props.settings,
      preventClicks: true,
      handleKeyboard: true,
      parentElement: props.parentElement,
      breaks: props.breaks,
      initialBreak: props.initialBreak,
      fitHeight: props.fitHeight,
      events: {
        onDrag: () => console.log('Drag event')
      }
    }
  )

  //instancePane.present({animate: true}).then(res => {});
  instancePane.on('onDidDismiss', () => emit('update:shown', false))

  pane.value = markRaw(instancePane)
})

// Show/Hide [BEGIN]
watch(() => props.shown, (value) => {
  const { value: instancePane } = pane

  console.log(instancePane)
  if (instancePane) {
    if (value) {
      instancePane.present({
        animate: true,
      })
    } else {
      instancePane.hide()      
    }
  }
})
// Show/Hide [END]

onBeforeUnmount(() => {
  const { value: instancePane } = pane

  if (instancePane) {
    instancePane.destroy({animate: true})
  }
})
</script>